{ pkgs, config, lib, ... }:

let
  cfg = config.pods;

  podOpts = with lib; {
    container = mkOption {
      type = types.attrsOf (types.submodule ({ options = podContainerOpts; }));
    };
    
    exportPorts = mkOption {
      type = types.listOf types.str;
    };

    routes = mkOption {
      type = types.attrsOf (types.submodule ({ options = routeOpts; }));
    };
  };

  podContainerOpts = with lib; {
    image = mkOption {
      type = types.str;
    };
    
    ports = mkOption {
      type = types.listOf types.str;
    };
    
    environment = mkOption {
      type = types.attrsOf types.str;
    };
    
    secrets = mkOption {
      type = types.attrsOf types.path;
    };

    volumes = mkOption {
      type = types.attrsOf types.str;
    };
  };

  routeOpts = with lib; {
    port = mkOption {
      type = types.str;
    };
  };
in {
  options.pods = with lib; {
    enable = mkEnableOption "Enable pod support";
    
    pods = mkOption {
      type = types.attrsOf (types.submodule ({ options = podOpts; }));
    };
  };

  config = lib.mkIf cfg.enable {
    
  }
}
